Index: branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/HeuristicLab.Problems.Instances.LinearOrdering-3.3.csproj
===================================================================
--- branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/HeuristicLab.Problems.Instances.LinearOrdering-3.3.csproj	(revision 15541)
+++ branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/HeuristicLab.Problems.Instances.LinearOrdering-3.3.csproj	(revision 15541)
@@ -0,0 +1,106 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{648F0BF0-6301-448C-816F-DEB1E65EC73F}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.Problems.Instances.LinearOrdering</RootNamespace>
+    <AssemblyName>HeuristicLab.Problems.Instances.LinearOrdering-3.3</AssemblyName>
+    <TargetFrameworkVersion>v4.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <TargetFrameworkProfile />
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>..\..\..\..\trunk\sources\bin\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>..\..\bin\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup>
+    <SignAssembly>true</SignAssembly>
+  </PropertyGroup>
+  <PropertyGroup>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="HeuristicLab.Common-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.PluginInfrastructure-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.PluginInfrastructure-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.IO.Compression" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Net.Http" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="LOPDataDescriptor.cs" />
+    <Compile Include="LOPXLOLIBInstanceProvider.cs" />
+    <Compile Include="LOPSPECInstanceProvider.cs" />
+    <Compile Include="LOPSGBInstanceProvider.cs" />
+    <Compile Include="LOPRANDBInstanceProvider.cs" />
+    <Compile Include="LOPRANDA2InstanceProvider.cs" />
+    <Compile Include="LOPRANDA1InstanceProvider.cs" />
+    <Compile Include="LOPMBInstanceProvider.cs" />
+    <Compile Include="LOPIOInstanceProvider.cs" />
+    <Compile Include="LOPParser.cs" />
+    <Compile Include="Plugin.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <EmbeddedResource Include="Data\IO.zip" />
+    <EmbeddedResource Include="Data\MB.zip" />
+    <EmbeddedResource Include="Data\RANDA1.zip" />
+    <EmbeddedResource Include="Data\RANDA2.zip" />
+    <EmbeddedResource Include="Data\RANDB.zip" />
+    <EmbeddedResource Include="Data\SGB.zip" />
+    <EmbeddedResource Include="Data\SPEC.zip" />
+    <EmbeddedResource Include="Data\XLOLIB.zip" />
+    <None Include="HeuristicLab.snk" />
+    <None Include="Plugin.cs.frame" />
+    <None Include="Properties\AssemblyInfo.cs.frame" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Problems.Instances\3.3\HeuristicLab.Problems.Instances-3.3.csproj">
+      <Project>{3540e29e-4793-49e7-8ee2-fea7f61c3994}</Project>
+      <Name>HeuristicLab.Problems.Instances-3.3</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd
+</PreBuildEvent>
+  </PropertyGroup>
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPDataDescriptor.cs
===================================================================
--- branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPDataDescriptor.cs	(revision 15541)
+++ branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPDataDescriptor.cs	(revision 15541)
@@ -0,0 +1,42 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Problems.Instances;
+
+namespace HeuristicLab.Problems.Instances.LinearOrdering
+{
+    internal class LOPDataDescriptor : IDataDescriptor
+    {
+        public string Name { get; internal set; }
+        public string Description { get; internal set; }
+
+        internal string InstanceIdentifier { get; set; }
+        internal string SolutionIdentifier { get; set; }
+
+        internal LOPDataDescriptor(string name, string description, string instanceIdentifier, string solutionIdentifier)
+        {
+            this.Name = name;
+            this.Description = description;
+            this.InstanceIdentifier = instanceIdentifier;
+            this.SolutionIdentifier = solutionIdentifier;
+        }
+    }
+}
Index: branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPIOInstanceProvider.cs
===================================================================
--- branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPIOInstanceProvider.cs	(revision 15541)
+++ branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPIOInstanceProvider.cs	(revision 15541)
@@ -0,0 +1,123 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Problems.Instances.Types;
+using System;
+using System.Collections.Generic;
+using System.IO;
+using System.IO.Compression;
+using System.Linq;
+using System.Reflection;
+using System.Text.RegularExpressions;
+
+namespace HeuristicLab.Problems.Instances.LinearOrdering
+{
+    public class LOPIOInstanceProvider : ProblemInstanceProvider<LOPData>
+    {
+
+        public override string Name {
+            get { return "IO"; }
+        }
+
+        public override string Description {
+            get { return "Linear Ordering Problems IO test instances"; }
+        }
+
+        public override Uri WebLink {
+            get { return new Uri("http://www.optsicom.es/lolib/lop/IO.zip"); }
+        }
+
+        public override string ReferencePublication {
+            get { return String.Empty; }
+        }
+
+        public override IEnumerable<IDataDescriptor> GetDataDescriptors()
+        {
+            var instanceArchiveName = GetResourceName("IO.zip");
+            if (String.IsNullOrEmpty(instanceArchiveName)) yield break;
+
+            using (var instanceStream = new ZipArchive(GetType().Assembly.GetManifestResourceStream(instanceArchiveName), ZipArchiveMode.Read))
+            {
+                foreach (var entry in instanceStream.Entries.Select(x => x.Name).OrderBy(x => x))
+                {
+                    yield return new LOPDataDescriptor(Path.GetFileNameWithoutExtension(entry), GetDescription(), entry, null);
+                }
+            }
+        }
+
+        public override LOPData LoadData(IDataDescriptor id)
+        {
+            var descriptor = (LOPDataDescriptor)id;
+            var instanceArchiveName = GetResourceName("IO.zip");
+            using (var instancesZipFile = new ZipArchive(GetType().Assembly.GetManifestResourceStream(instanceArchiveName), ZipArchiveMode.Read))
+            {
+                var entry = instancesZipFile.GetEntry(descriptor.InstanceIdentifier);
+
+                using (var stream = entry.Open())
+                {
+                    var parser = new LOPParser();
+                    parser.Parse(stream);
+                    return Load(parser);
+                }
+            }
+        }
+
+        public override bool CanImportData {
+            get { return true; }
+        }
+
+        public override LOPData ImportData(string path)
+        {
+            var parser = new LOPParser();
+            parser.Parse(path);
+            return Load(parser);
+        }
+
+        private LOPData Load(LOPParser parser)
+        {
+            var instance = new LOPData
+            {
+                Name = parser.Name,
+                Description = parser.Description,
+                Dimension = parser.Dimension,
+                Matrix = parser.Matrix,
+                BestKnownPermutation = parser.BestKnownPermutation,
+                BestKnownQuality = parser.BestKnownQuality
+            };
+            return instance;
+        }
+
+        public override bool CanExportData {
+            get { return false; }
+        }
+
+        private string GetDescription()
+        {
+            return "Embedded instance of plugin version " + Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyFileVersionAttribute), true).Cast<AssemblyFileVersionAttribute>().First().Version + ".";
+        }
+
+        protected virtual string GetResourceName(string fileName)
+        {
+            return Assembly.GetExecutingAssembly().GetManifestResourceNames()
+              .SingleOrDefault(x => Regex.Match(x, @".*\.Data\." + fileName).Success);
+        }
+    }
+}
Index: branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPMBInstanceProvider.cs
===================================================================
--- branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPMBInstanceProvider.cs	(revision 15541)
+++ branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPMBInstanceProvider.cs	(revision 15541)
@@ -0,0 +1,122 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Problems.Instances.Types;
+using System;
+using System.Collections.Generic;
+using System.IO;
+using System.IO.Compression;
+using System.Linq;
+using System.Reflection;
+using System.Text.RegularExpressions;
+
+namespace HeuristicLab.Problems.Instances.LinearOrdering
+{
+    public class LOPMBInstanceProvider : ProblemInstanceProvider<LOPData>
+    {
+
+        public override string Name {
+            get { return "MB"; }
+        }
+
+        public override string Description {
+            get { return "Linear Ordering Problems MB test instances"; }
+        }
+
+        public override Uri WebLink {
+            get { return new Uri("http://www.optsicom.es/lolib/lop/MB.zip"); }
+        }
+
+        public override string ReferencePublication {
+            get { return String.Empty; }
+        }
+
+        public override IEnumerable<IDataDescriptor> GetDataDescriptors()
+        {
+            var instanceArchiveName = GetResourceName("MB.zip");
+            if (String.IsNullOrEmpty(instanceArchiveName)) yield break;
+
+            using (var instanceStream = new ZipArchive(GetType().Assembly.GetManifestResourceStream(instanceArchiveName), ZipArchiveMode.Read))
+            {
+                foreach (var entry in instanceStream.Entries.Select(x => x.Name).OrderBy(x => x))
+                {
+                    yield return new LOPDataDescriptor(Path.GetFileNameWithoutExtension(entry), GetDescription(), entry, null);
+                }
+            }
+        }
+
+        public override LOPData LoadData(IDataDescriptor id)
+        {
+            var descriptor = (LOPDataDescriptor)id;
+            var instanceArchiveName = GetResourceName("MB.zip");
+            using (var instancesZipFile = new ZipArchive(GetType().Assembly.GetManifestResourceStream(instanceArchiveName), ZipArchiveMode.Read))
+            {
+                var entry = instancesZipFile.GetEntry(descriptor.InstanceIdentifier);
+
+                using (var stream = entry.Open())
+                {
+                    var parser = new LOPParser();
+                    parser.Parse(stream);
+                    return Load(parser);
+                }
+            }
+        }
+
+        public override bool CanImportData {
+            get { return true; }
+        }
+        public override LOPData ImportData(string path)
+        {
+            var parser = new LOPParser();
+            parser.Parse(path);
+            return Load(parser);
+        }
+
+        private LOPData Load(LOPParser parser)
+        {
+            var instance = new LOPData
+            {
+                Name = parser.Name,
+                Description = parser.Description,
+                Dimension = parser.Dimension,
+                Matrix = parser.Matrix,
+                BestKnownPermutation = parser.BestKnownPermutation,
+                BestKnownQuality = parser.BestKnownQuality
+            };
+            return instance;
+        }
+
+        public override bool CanExportData {
+            get { return false; }
+        }
+        
+        private string GetDescription()
+        {
+            return "Embedded instance of plugin version " + Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyFileVersionAttribute), true).Cast<AssemblyFileVersionAttribute>().First().Version + ".";
+        }
+
+        protected virtual string GetResourceName(string fileName)
+        {
+            return Assembly.GetExecutingAssembly().GetManifestResourceNames()
+              .SingleOrDefault(x => Regex.Match(x, @".*\.Data\." + fileName).Success);
+        }
+    }
+}
Index: branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPParser.cs
===================================================================
--- branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPParser.cs	(revision 15541)
+++ branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPParser.cs	(revision 15541)
@@ -0,0 +1,128 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Globalization;
+using System.IO;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Problems.Instances.LinearOrdering
+{
+    public class LOPParser
+    {
+        public string Name { get; set; }
+        public string Description { get; set; }
+        public int Dimension { get; set; }
+        public double[,] Matrix { get; set; }
+        public int[] BestKnownPermutation { get; set; }
+        public double? BestKnownQuality { get; set; }
+
+        public LOPParser()
+        {
+            Reset();
+        }
+
+        public void Reset()
+        {
+            Name = Description = String.Empty;
+            Dimension = 0;
+            BestKnownQuality = 0;
+            Matrix = null;
+            BestKnownPermutation = null;
+        }
+
+        public void Parse(string file)
+        {
+            using (Stream stream = new FileStream(file, FileMode.Open, FileAccess.Read))
+            {
+                Parse(stream);
+            }
+        }
+
+        public void Export(string file)
+        {
+            using (Stream stream = new FileStream(file, FileMode.Create, FileAccess.Write))
+            {
+                Export(stream);
+            }
+        }
+
+        public void Parse(Stream stream)
+        {
+            using (var reader = new StreamReader(stream, Encoding.UTF8, true, 4092, true))
+            {
+                Name = reader.ReadLine().Trim();
+                Description = reader.ReadLine().Trim();
+                BestKnownQuality = double.Parse(reader.ReadLine().Trim());
+                var delim = new char[] { ' ', '\t' };
+
+                Dimension = int.Parse(reader.ReadLine().Trim());
+                Matrix = new double[Dimension, Dimension];
+
+                for (int k = 0; k < Dimension; k++)
+                {
+                    if (reader.EndOfStream) throw new InvalidDataException("Unexpected End of Stream.");
+                    var valLine = reader.ReadLine();
+                    while (String.IsNullOrWhiteSpace(valLine)) valLine = reader.ReadLine();
+                    var vals = valLine.Split(delim, StringSplitOptions.RemoveEmptyEntries);
+
+
+                    for (int i = 0; i < Dimension; i++)
+                    {
+                        Matrix[k, i] = double.Parse(vals[i], CultureInfo.InvariantCulture.NumberFormat);
+                    }
+                }
+
+                while (!reader.EndOfStream)
+                {
+                    var vals = reader.ReadLine().Split(delim, StringSplitOptions.RemoveEmptyEntries);
+                    if (vals.Count() == Dimension) { BestKnownPermutation = vals.Select(val => Int32.Parse(val)).ToArray(); }
+                }
+            }
+        }
+
+        public void Export(Stream stream)
+        {
+            using (var writer = new StreamWriter(stream, Encoding.UTF8, 4092, true))
+            {
+                writer.WriteLine(Name);
+                writer.WriteLine(Description);
+                writer.WriteLine(BestKnownQuality);
+                writer.WriteLine(Dimension);
+
+                for (int k = 0; k < Dimension; k++)
+                {
+                    for (int i = 0; i < Dimension; i++)
+                    {
+                        writer.Write(Matrix[k, i] + '\t');
+                    }
+                    writer.WriteLine();
+                }
+
+                if (BestKnownPermutation != null) { 
+                    writer.WriteLine(BestKnownPermutation);
+                }
+                writer.Flush();
+            }
+        }
+    }
+}
Index: branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPRANDA1InstanceProvider.cs
===================================================================
--- branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPRANDA1InstanceProvider.cs	(revision 15541)
+++ branches/2864_PermutationProblems/HeuristicLab.Problems.Instances.LinearOrdering/3.3/LOPRANDA1InstanceProvider.cs	(revision 15541)
@@ -0,0 +1,122 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Problems.Instances.Types;
+using System;
+using System.Collections.Generic;
+using System.IO;
+using System.IO.Compression;
+using System.Linq;
+using System.Reflection;
+using System.Text.RegularExpressions;
+
+namespace HeuristicLab.Problems.Instances.LinearOrdering
+{
+    public class LOPRANDA1InstanceProvider : ProblemInstanceProvider<LOPData>
+    {
+
+        public override string Name {
+            get { return "RANDA1"; }
+        }
+
+        public override string Description {
+            get { return "Linear Ordering Problems RANDA1 test instances"; }
+        }
+
+        public override Uri WebLink {
+            get { return new Uri("http://www.optsicom.es/lolib/lop/RANDA1.zip"); }
+        }
+
+        public override string ReferencePublication {
+            get { return String.Empty; }
+        }
+
+        public override IEnumerable<IDataDescriptor> GetDataDescriptors()
+        {
+            var instanceArchiveName = GetResourceName("RANDA1.zip");
+            if (String.IsNullOrEmpty(instanceArchiveName)) yield break;
+
+            using (var instanceStream = new ZipArchive(GetType().Assembly.GetManifestResourceStream(instanceArchiveName), ZipArchiveMode.Read))
+            {
+                foreach (var entry in instanceStream.Entries.Select(x => x.Name).OrderBy(x => x))
+                {
+                    yield return new LOPDataDescriptor(Path.GetFileNameWithoutExtension(entry), GetDescription(), entry, null);
+                }
+            }
+        }
+
+        public override LOPData LoadData(IDataDescriptor id)
+        {
+            var descriptor = (LOPDataDescriptor)id;
+            var instanceArchiveName = GetResourceName("RANDA1.zip");
+            using (var instancesZipFile = new ZipArchive(GetType().Assembly.GetManifestResourceStream(instanceArchiveName), ZipArchiveMode.Read))
+            {
+                var entry = instancesZipFile.GetEntry(descriptor.InstanceIdentifier);
+
+                using (var stream = entry.Open())
+                {
+                    var parser = new LOPParser();
+                    parser.Parse(stream);
+                    return Load(parser);
+                }
+            }
+        }
+
+        public override bool CanImportData {
+            get { return true; }
+        }
+        public override LOPData ImportData(string path)
+        {
+            var parser = new LOPParser();
+            parser.Parse(path);
+            return Load(parser);
+        }
+
+        private LOPData Load(LOPParser parser)
+        {
+            var instance = new LOPData
+            {
+                Name = parser.Name,
+                Description = parser.Description,
+                Dimension = parser.Dimension,
+                Matrix = parser.Matrix,
+                BestKnownPermutation = parser.BestKnownPermutation,
+                BestKnownQuality = parser.BestKnownQuality
+            };
+            return instance;
+        }
+
+        public override bool CanExportData {
+            get { return false; }
+        }
+
+        private string GetDescription()
+        {
+            return "Embedded instance of plugin version " + Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(AssemblyFileVersionAttribute), true).Cast<AssemblyFileVersionAttribute>().First().Version + ".";
+        }
+
+        protected virtual string GetResourceName(string fileName)
+        {
+            return Assembly.GetExecutingAssembly().GetManifestResourceNames()
+              .SingleOrDefault(x => Regex.Match(x, @".*\.Data\." + fileName).Success);
+        }
+    }
+}
